//
// Created by Yannis Goore on 2019-05-10.
//

#include "Explosion.h"
#include <stdio.h>
#include <time.h>
#include <allegro5/allegro.h>
#include <stdbool.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_audio.h>
#include "Explosion.h"
void startExplosions(explosion explosions[], int size, int x, int y)
{
    for(int i = 0; i < size; i++)
    {
        if(!explosions[i].actif)
        {
            explosions[i].actif = true;
            explosions[i].x = x;
            explosions[i].y = y;
            break;
        }
    }
}
void initExplosions(explosion explosions[], int nbexplos, ALLEGRO_BITMAP*image )
{
    for(int i = 0; i < nbexplos; i++)
    {
        explosions[i].actif = false;

        explosions[i].maxFrame = 16;
        explosions[i].curFrame = 0;
        explosions[i].frameCount = 0;
        explosions[i].frameDelay = 1;
        explosions[i].frameWidth = 64;
        explosions[i].frameHeight = 64;
        explosions[i].animationColumns = 4;
        explosions[i].animationDirection = 1;

        if(image != NULL)
            explosions[i].image = image;
    }
}

void drawExplosions(explosion explosions[], int nbexplos)
{
    for(int i = 0; i < nbexplos; i++)
    {
        if(explosions[i].actif)
        {
            int fx = (explosions[i].curFrame % explosions[i].animationColumns) * explosions[i].frameWidth;
            int fy = (explosions[i].curFrame / explosions[i].animationColumns) * explosions[i].frameHeight;

            al_draw_bitmap_region(explosions[i].image, fx, fy, explosions[i].frameWidth,
                                  explosions[i].frameHeight, explosions[i].x - explosions[i].frameWidth / 2, explosions[i].y - explosions[i].frameHeight / 2, 0);
        }
    }
}

void updateExplosions(explosion explosions[], int nbexplo)
{
    for(int i = 0; i < nbexplo; i++)
    {
        if(explosions[i].actif)
        {
            if(++explosions[i].frameCount >= explosions[i].frameDelay)
            {
                explosions[i].curFrame += explosions[i].animationDirection;
                if(explosions[i].curFrame >= explosions[i].maxFrame)
                {
                    explosions[i].curFrame = 0;
                    explosions[i].actif = false;
                }

                explosions[i].frameCount = 0;
            }
        }
    }
}
