//
// Created by Yannis Goore on 2019-05-09.
//

#include "MISSILES.h"
#include "BOSS .h"
#include "ennemis.h"
#include "Explosion.h"
#include "vaisseau.h"
#include "SAMPLES.h"
#include "allegro5/allegro_acodec.h"
#include <allegro5/allegro_audio.h>

void init_missiles(missile missiles[]) {
    int i = 0;
    for (i = 0; i < NB_MAX_MISSILES; i++) {
        missiles[i].v = 10;
        missiles[i].actif = 0;
    }
}

void affiche_missiles(missile missiles[]) {
    int i = 0;
    for (i = 0; i < NB_MAX_MISSILES; i++) {
        if (missiles[i].actif) {
            al_draw_filled_ellipse(missiles[i].x, missiles[i].y, 3, 2, al_map_rgb(255, 255, 0));
        }
    }
}

void avance_missiles(missile missiles[]) {
    int i = 0;
    for (i = 0; i < NB_MAX_MISSILES; i++) {
        if (missiles[i].actif) {
            missiles[i].x += missiles[i].v;
            if (missiles[i].x >= SCREEN_WIDTH) {
                missiles[i].actif = 0;
            }
        }
    }
}
void avance_missileE(missile missiles[]){
    int i = 0;
    for (i = 0; i < NB_MAX_MISSILES; i++) {
        if (missiles[i].actif) {
            missiles[i].x -= missiles[i].v;
            if (missiles[i].x >= SCREEN_WIDTH) {
                missiles[i].actif = 0;
            }
        }
    }
}

void lancement_missile(vaisseau *vaisseau, missile missiles[]) {
    int i = 0;
    for (i = 0; i < NB_MAX_MISSILES; i++) {
        if (!missiles[i].actif) {
            missiles[i].actif = 1;
            missiles[i].x = vaisseau->x + vaisseau->tx;
            missiles[i].y = vaisseau->y + vaisseau->ty / 2;
            al_play_sample(audioTir,1,0,1,ALLEGRO_PLAYMODE_ONCE,0);
            break;
        }
    }
}





void lancement_missileEnnemi(ennemisfix ennemisFixes[], missile missiles[]) {
   int i=0;
    for ( i=0 ; i <5; ++i) {

            if (!missiles[i].actif) {
                missiles[i].actif = 1;
                printf("tout va bien ici");
                missiles[i].x = ennemisFixes[i].x + ennemisFixes[i].tx;
                missiles[i].y = ennemisFixes[i].y + ennemisFixes[i].ty / 2;
                printf("tout va bien ENNEMIS LANCEMENT MISS %d",i);
                break;
            }
        }
    }


void collison_missilLEnnemi_VAISSEAU(missile missiles[],vaisseau*vaisseau,explosion explosions[]){
    int i=0;

    for ( i=0 ; i < NB_MAX_MISSILES; ++i) {
        if (missiles[i].actif &&
            missiles[i].x > vaisseau->x - vaisseau->tx &&
            vaisseau->y > vaisseau->y - vaisseau->ty &&
            missiles[i].y < vaisseau->y + vaisseau->ty) {
            missiles[i].actif = 0;
            vaisseau->vie--;
            startExplosions(explosions,NB_MAX_EXPLOSIONS,missiles[i].x,missiles[i].y);
            al_play_sample(audioExplosion,1,0,1,ALLEGRO_PLAYMODE_ONCE,0);
        }




    }

}

void drawmissileEnnemi(missile missiles[]){
    int i=0;
    for(i=0;i<NB_MAX_MISSILES;i++){
        if (missiles[i].actif) {
            al_draw_filled_ellipse(missiles[i].x, missiles[i].y, 3, 2, al_map_rgb(255, 0, 0));
        }
    }
}

// MISSILES DU VAISSEAU COLLISION
void collision_missile(missile missiles[], ennemi ennemis[], vaisseau *vaisseau,explosion explosions[],BOSSFINAL*BOSSFINAL) {
    int i = 0, j = 0;
    for (i = 0; i < NB_MAX_ENNEMIS; i++) {
        if (ennemis[i].actif) {
            for (j = 0; j < NB_MAX_MISSILES; j++) {
                if (missiles[j].actif &&
                    missiles[j].x > ennemis[i].x - ennemis[i].tx &&
                    missiles[j].y > ennemis[i].y - ennemis[i].ty &&
                    missiles[j].y < ennemis[i].y + ennemis[i].ty) {
                    missiles[j].actif = 0;
                    ennemis[i].actif = 0;
                    vaisseau->score++;
                    startExplosions(explosions,NB_MAX_EXPLOSIONS,missiles[i].x,missiles[i].y);
                    al_play_sample(audioExplosion,1,0,1,ALLEGRO_PLAYMODE_ONCE,0);
                }


                if (missiles[j].actif &&
                    missiles[j].x > BOSSFINAL->x - BOSSFINAL->tx &&
                    missiles[j].y > BOSSFINAL->y - BOSSFINAL->ty &&
                    missiles[j].y < BOSSFINAL->y + BOSSFINAL->ty) {
                    missiles[j].actif = 0;
                    BOSSFINAL->vie--;

                    if (BOSSFINAL->vie==0){
                        BOSSFINAL->actif=0;
                    }
                    vaisseau->score++;

                }
            }
        }
    }
}

void collision_missille_vaisseau_ennemisfixes(missile missiles[],vaisseau *vaisseau,explosion explosions[],ennemisfix ennemisfixes [] ){
    int i = 0, j = 0;
    for (i = 0; i < NB_MAX_ENNEMIES_FIXES_LVL1; i++) {
        if (ennemisfixes[i].actif) {
            for (j = 0; j < NB_MAX_MISSILES; j++) {
                if (missiles[j].actif &&
                    missiles[j].x > ennemisfixes[i].x - ennemisfixes[i].tx &&
                    missiles[j].y > ennemisfixes[i].y - ennemisfixes[i].ty &&
                    missiles[j].y < ennemisfixes[i].y + ennemisfixes[i].ty) {
                    missiles[j].actif = 0;
                    ennemisfixes[i].actif = 0;
                    startExplosions(explosions,NB_MAX_EXPLOSIONS,missiles[i].x,missiles[i].y);
                    al_play_sample(audioExplosion,5,0,1,ALLEGRO_PLAYMODE_ONCE,0);
                    vaisseau->score++;
                }

            }
        }
    }
}
void collision_missile_NIV2(missile missiles[], ennemi ennemis[], vaisseau *vaisseau,explosion explosions[],BOSSFINAL*BOSSFINAL) {
    int i = 0, j = 0;
    for (i = 0; i < NB_MAX_ENNEMIS; i++) {
        if (ennemis[i].actif) {
            for (j = 0; j < NB_MAX_MISSILES; j++) {
                if (missiles[j].actif &&
                    missiles[j].x > ennemis[i].x - ennemis[i].tx &&
                    missiles[j].y > ennemis[i].y - ennemis[i].ty &&
                    missiles[j].y < ennemis[i].y + ennemis[i].ty) {
                    missiles[j].actif = 0;
                    ennemis[i].vie--;
                    vaisseau->score++;
                    startExplosions(explosions,NB_MAX_EXPLOSIONS,missiles[i].x,missiles[i].y);
                    al_play_sample(audioExplosion,1,0,1,ALLEGRO_PLAYMODE_ONCE,0);
                }
                if (ennemis[i].vie==0){
                    ennemis[i].actif=false;
                }
            }

                if (missiles[j].actif &&
                    missiles[j].x > BOSSFINAL->x - BOSSFINAL->tx &&
                    missiles[j].y > BOSSFINAL->y - BOSSFINAL->ty &&
                    missiles[j].y < BOSSFINAL->y + BOSSFINAL->ty) {
                    printf("Ah la on est bien là %d",j);
                    missiles[j].actif = 0;
                    BOSSFINAL->vie--;

                    if (BOSSFINAL->vie==0){
                        BOSSFINAL->actif=0;
                    }

                }
            }

    }
}

void start_missile_BOSS(BOSSFINAL*BOSSFINAL,missile missiles[] ){
    int i=0;
    for ( i = 0; i <NB_MAX_MISSILES ; ++i) {
        if (!missiles[i].actif) {
            missiles[i].actif = 1;
            missiles[i].x = BOSSFINAL->x + BOSSFINAL->tx;
            missiles[i].y = BOSSFINAL->y + BOSSFINAL->ty / 2;
            break;
        }
    }

}



void drawMissile(missile missiles[]){
    int i=0;
    for(i=0;i<NB_MAX_MISSILES;i++){
        if (missiles[i].actif) {
            al_draw_bitmap(missiles[i].imageE,missiles[i].x,missiles[i].y,0);
        }
    }
}