//
// Created by Yannis Goore on 2019-05-09.
//

#include "vaisseau.h"
#include <stdio.h>
#include <time.h>
#include <allegro5/allegro.h>
#include <stdbool.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_audio.h>
#define NB_MAX_ETOILES 250
#define SCREEN_WIDTH 2400
#define SCREEN_HEIGHT 1200
#define NOIR al_map_rgb(0,0,0)
#define NB_MAX_ENNEMIS 10
#define NB_MAX_MISSILES 12
#define NB_MAX_EXPLOSIONS 10
#define NB_MAX_BONUS 5
#define NB_MAX_ENNEMIES_FIXES_LVL1  10

void init_vaisseau(vaisseau *vaisseau) {
    vaisseau->x = 20;
    vaisseau->y = SCREEN_HEIGHT/2;
    vaisseau->v = 7;
    vaisseau->tx = 30;
    vaisseau->ty = 20;
    vaisseau->vie = 3;
    vaisseau->score = 0;
    vaisseau->image = al_load_bitmap("/Users/Yannisgoore/Downloads/vaisseau.png"
    );
    if (!vaisseau->image) {
        vaisseau->image = al_create_bitmap(vaisseau->tx, vaisseau->ty);
        al_set_target_bitmap(vaisseau->image);
        al_clear_to_color(NOIR);
        al_draw_filled_triangle(0, 0, 0, vaisseau->ty, vaisseau->tx, vaisseau->ty / 2,
                                al_map_rgb(200, 200, 255));
    } else {
        vaisseau->tx = al_get_bitmap_width(vaisseau->image);
        vaisseau->ty = al_get_bitmap_height(vaisseau->image);
        //printf("Chargement vaisseau OK\n");
    }
}


void affiche_vaisseau(vaisseau *vaisseau) {
    al_draw_bitmap(vaisseau->image, vaisseau->x, vaisseau->y, 0);
    //printf("chargement vaisseau ok");
}

void monte(vaisseau *vaisseau) {
    vaisseau->y = (vaisseau->y - vaisseau->v < 0) ? 0 : vaisseau->y - vaisseau->v;
}

void descend(vaisseau *vaisseau) {
    vaisseau->y = (vaisseau->y + vaisseau->ty + vaisseau->v > SCREEN_HEIGHT) ? SCREEN_HEIGHT -
                                                                               vaisseau->ty :
                  vaisseau->y + vaisseau->v;
}

void gauche(vaisseau *vaisseau) {
    vaisseau->x = (vaisseau->x - vaisseau->v < 0) ? 0 : vaisseau->x - vaisseau->v;
}

void droite(vaisseau *vaisseau) {
    vaisseau->x = (vaisseau->x + vaisseau->v >= SCREEN_WIDTH - 90) ? SCREEN_WIDTH - 90 : vaisseau->x +
                                                                                         vaisseau->v;
}

void collision_vaisseau(vaisseau *vaisseau, ennemi ennemis[], explosion explosions[]) {
    int i = 0;
    for (i = 0; i < NB_MAX_ENNEMIS; i++) {
        if (ennemis[i].actif) {
            int x1 = ennemis[i].x - ennemis[i].tx;
            int y1 = ennemis[i].y - ennemis[i].ty;
            int x2 = ennemis[i].x;
            int y2 = ennemis[i].y + ennemis[i].ty;

            if (vaisseau->x + vaisseau->tx > x1 && vaisseau->x < x2 &&
                vaisseau->y + vaisseau->ty > y1 && vaisseau->y < y2) {
                vaisseau->vie--;
                startExplosions(explosions,NB_MAX_EXPLOSIONS, vaisseau->x,vaisseau->y);
                ennemis[i].actif = 0;

            }
        }
    }
}